//
// Copyright 2020 FoxyUtils ehf. All rights reserved.
//
// This is a commercial product and requires a license to operate.
// A trial license can be obtained at https://unidoc.io
//
// DO NOT EDIT: generated by unitwist Go source code obfuscator.
//
// Use of this source code is governed by the UniDoc End User License Agreement
// terms that can be accessed at https://unidoc.io/eula/

// Package fdf provides support for loading form field data from Form Field Data (FDF) files.
package fdf ;import (_b "bufio";_gb "bytes";_af "encoding/hex";_c "errors";_da "fmt";_dg "github.com/unidoc/unipdf/v3/common";_gf "github.com/unidoc/unipdf/v3/core";_ac "io";_ge "os";_f "regexp";_ff "sort";_a "strconv";_g "strings";);

// LoadFromPath loads FDF form data from file path `fdfPath`.
func LoadFromPath (fdfPath string )(*Data ,error ){_gd ,_bc :=_ge .Open (fdfPath );if _bc !=nil {return nil ,_bc ;};defer _gd .Close ();return Load (_gd );};var _gee =_f .MustCompile ("\u0025F\u0044F\u002d\u0028\u005c\u0064\u0029\u005c\u002e\u0028\u005c\u0064\u0029");
func (_abb *fdfParser )parseName ()(_gf .PdfObjectName ,error ){var _gfg _gb .Buffer ;_cab :=false ;for {_gge ,_gbc :=_abb ._gde .Peek (1);if _gbc ==_ac .EOF {break ;};if _gbc !=nil {return _gf .PdfObjectName (_gfg .String ()),_gbc ;};if !_cab {if _gge [0]=='/'{_cab =true ;
_abb ._gde .ReadByte ();}else if _gge [0]=='%'{_abb .readComment ();_abb .skipSpaces ();}else {_dg .Log .Debug ("\u0045\u0052\u0052\u004f\u0052\u0020N\u0061\u006d\u0065\u0020\u0073\u0074\u0061\u0072\u0074\u0069\u006e\u0067\u0020w\u0069\u0074\u0068\u0020\u0025\u0073\u0020(\u0025\u0020\u0078\u0029",_gge ,_gge );
return _gf .PdfObjectName (_gfg .String ()),_da .Errorf ("\u0069n\u0076a\u006c\u0069\u0064\u0020\u006ea\u006d\u0065:\u0020\u0028\u0025\u0063\u0029",_gge [0]);};}else {if _gf .IsWhiteSpace (_gge [0]){break ;}else if (_gge [0]=='/')||(_gge [0]=='[')||(_gge [0]=='(')||(_gge [0]==']')||(_gge [0]=='<')||(_gge [0]=='>'){break ;
}else if _gge [0]=='#'{_bcfc ,_ggd :=_abb ._gde .Peek (3);if _ggd !=nil {return _gf .PdfObjectName (_gfg .String ()),_ggd ;};_abb ._gde .Discard (3);_ecc ,_ggd :=_af .DecodeString (string (_bcfc [1:3]));if _ggd !=nil {return _gf .PdfObjectName (_gfg .String ()),_ggd ;
};_gfg .Write (_ecc );}else {_gef ,_ :=_abb ._gde .ReadByte ();_gfg .WriteByte (_gef );};};};return _gf .PdfObjectName (_gfg .String ()),nil ;};

// Root returns the Root of the FDF document.
func (_eff *fdfParser )Root ()(*_gf .PdfObjectDictionary ,error ){if _eff ._eab !=nil {if _fag ,_cag :=_eff .trace (_eff ._eab .Get ("\u0052\u006f\u006f\u0074")).(*_gf .PdfObjectDictionary );_cag {if _aac ,_ffa :=_eff .trace (_fag .Get ("\u0046\u0044\u0046")).(*_gf .PdfObjectDictionary );
_ffa {return _aac ,nil ;};};};var _fgbg []int64 ;for _aaaa :=range _eff ._ca {_fgbg =append (_fgbg ,_aaaa );};_ff .Slice (_fgbg ,func (_gbbd ,_fda int )bool {return _fgbg [_gbbd ]< _fgbg [_fda ]});for _ ,_egee :=range _fgbg {_bdg :=_eff ._ca [_egee ];if _cac ,_cc :=_eff .trace (_bdg ).(*_gf .PdfObjectDictionary );
_cc {if _abeb ,_bcd :=_eff .trace (_cac .Get ("\u0046\u0044\u0046")).(*_gf .PdfObjectDictionary );_bcd {return _abeb ,nil ;};};};return nil ,_c .New ("\u0046\u0044\u0046\u0020\u006e\u006f\u0074\u0020\u0066\u006f\u0075\u006e\u0064");};func (_cf *fdfParser )parse ()error {_cf ._ga .Seek (0,_ac .SeekStart );
_cf ._gde =_b .NewReader (_cf ._ga );for {_cf .skipComments ();_fada ,_cfd :=_cf ._gde .Peek (20);if _cfd !=nil {_dg .Log .Debug ("\u0045\u0052\u0052\u004f\u0052\u003a\u0020\u0046\u0061\u0069\u006c\u0020\u0074\u006f\u0020r\u0065a\u0064\u0020\u0069\u006e\u0064\u0069\u0072\u0065\u0063\u0074\u0020\u006f\u0062\u006a");
return _cfd ;};if _g .HasPrefix (string (_fada ),"\u0074r\u0061\u0069\u006c\u0065\u0072"){_cf ._gde .Discard (7);_cf .skipSpaces ();_cf .skipComments ();_bbdf ,_ :=_cf .parseDict ();_cf ._eab =_bbdf ;break ;};_caea :=_fca .FindStringSubmatchIndex (string (_fada ));
if len (_caea )< 6{_dg .Log .Debug ("\u0045\u0052\u0052\u004f\u0052\u003a\u0020U\u006e\u0061\u0062l\u0065\u0020\u0074\u006f \u0066\u0069\u006e\u0064\u0020\u006f\u0062\u006a\u0065\u0063\u0074\u0020\u0073\u0069\u0067\u006e\u0061\u0074\u0075\u0072\u0065\u0020\u0028\u0025\u0073\u0029",string (_fada ));
return _c .New ("\u0075\u006e\u0061b\u006c\u0065\u0020\u0074\u006f\u0020\u0064\u0065\u0074\u0065\u0063\u0074\u0020\u0069\u006e\u0064\u0069\u0072\u0065\u0063\u0074\u0020\u006f\u0062\u006a\u0065\u0063\u0074\u0020s\u0069\u0067\u006e\u0061\u0074\u0075\u0072\u0065");
};_dbcc ,_cfd :=_cf .parseIndirectObject ();if _cfd !=nil {return _cfd ;};switch _gfc :=_dbcc .(type ){case *_gf .PdfIndirectObject :_cf ._ca [_gfc .ObjectNumber ]=_gfc ;case *_gf .PdfObjectStream :_cf ._ca [_gfc .ObjectNumber ]=_gfc ;default:return _c .New ("\u0074\u0079\u0070\u0065\u0020\u0065\u0072\u0072\u006f\u0072");
};};return nil ;};func (_eaf *fdfParser )readTextLine ()(string ,error ){var _ag _gb .Buffer ;for {_dfa ,_eda :=_eaf ._gde .Peek (1);if _eda !=nil {_dg .Log .Debug ("\u0045\u0072\u0072\u006f\u0072\u0020\u0025\u0073",_eda .Error ());return _ag .String (),_eda ;
};if (_dfa [0]!='\r')&&(_dfa [0]!='\n'){_fg ,_ :=_eaf ._gde .ReadByte ();_ag .WriteByte (_fg );}else {break ;};};return _ag .String (),nil ;};func (_cbe *fdfParser )seekToEOFMarker (_cdbb int64 )error {_bdcb :=int64 (0);_gda :=int64 (1000);for _bdcb < _cdbb {if _cdbb <=(_gda +_bdcb ){_gda =_cdbb -_bdcb ;
};_ ,_cecb :=_cbe ._ga .Seek (-_bdcb -_gda ,_ac .SeekEnd );if _cecb !=nil {return _cecb ;};_feg :=make ([]byte ,_gda );_cbe ._ga .Read (_feg );_dg .Log .Trace ("\u004c\u006f\u006f\u006bi\u006e\u0067\u0020\u0066\u006f\u0072\u0020\u0045\u004f\u0046 \u006da\u0072\u006b\u0065\u0072\u003a\u0020\u0022%\u0073\u0022",string (_feg ));
_cdd :=_be .FindAllStringIndex (string (_feg ),-1);if _cdd !=nil {_cae :=_cdd [len (_cdd )-1];_dg .Log .Trace ("\u0049\u006e\u0064\u003a\u0020\u0025\u0020\u0064",_cdd );_cbe ._ga .Seek (-_bdcb -_gda +int64 (_cae [0]),_ac .SeekEnd );return nil ;};_dg .Log .Debug ("\u0057\u0061\u0072\u006e\u0069\u006eg\u003a\u0020\u0045\u004f\u0046\u0020\u006d\u0061\u0072\u006b\u0065\u0072\u0020\u006e\u006f\u0074\u0020\u0066\u006f\u0075n\u0064\u0021\u0020\u002d\u0020\u0063\u006f\u006e\u0074\u0069\u006e\u0075\u0065\u0020s\u0065e\u006b\u0069\u006e\u0067");
_bdcb +=_gda ;};_dg .Log .Debug ("\u0045\u0072\u0072\u006f\u0072\u003a\u0020\u0045\u004f\u0046\u0020\u006d\u0061\u0072\u006be\u0072 \u0077\u0061\u0073\u0020\u006e\u006f\u0074\u0020\u0066\u006f\u0075\u006e\u0064\u002e");return _c .New ("\u0045\u004f\u0046\u0020\u006e\u006f\u0074\u0020\u0066\u006f\u0075\u006e\u0064");
};func (_edd *fdfParser )parseString ()(*_gf .PdfObjectString ,error ){_edd ._gde .ReadByte ();var _gga _gb .Buffer ;_bef :=1;for {_fcg ,_cdb :=_edd ._gde .Peek (1);if _cdb !=nil {return _gf .MakeString (_gga .String ()),_cdb ;};if _fcg [0]=='\\'{_edd ._gde .ReadByte ();
_dba ,_afe :=_edd ._gde .ReadByte ();if _afe !=nil {return _gf .MakeString (_gga .String ()),_afe ;};if _gf .IsOctalDigit (_dba ){_bfgb ,_de :=_edd ._gde .Peek (2);if _de !=nil {return _gf .MakeString (_gga .String ()),_de ;};var _gddc []byte ;_gddc =append (_gddc ,_dba );
for _ ,_geeb :=range _bfgb {if _gf .IsOctalDigit (_geeb ){_gddc =append (_gddc ,_geeb );}else {break ;};};_edd ._gde .Discard (len (_gddc )-1);_dg .Log .Trace ("\u004e\u0075\u006d\u0065ri\u0063\u0020\u0073\u0074\u0072\u0069\u006e\u0067\u0020\u0022\u0025\u0073\u0022",_gddc );
_eae ,_de :=_a .ParseUint (string (_gddc ),8,32);if _de !=nil {return _gf .MakeString (_gga .String ()),_de ;};_gga .WriteByte (byte (_eae ));continue ;};switch _dba {case 'n':_gga .WriteRune ('\n');case 'r':_gga .WriteRune ('\r');case 't':_gga .WriteRune ('\t');
case 'b':_gga .WriteRune ('\b');case 'f':_gga .WriteRune ('\f');case '(':_gga .WriteRune ('(');case ')':_gga .WriteRune (')');case '\\':_gga .WriteRune ('\\');};continue ;}else if _fcg [0]=='('{_bef ++;}else if _fcg [0]==')'{_bef --;if _bef ==0{_edd ._gde .ReadByte ();
break ;};};_bbc ,_ :=_edd ._gde .ReadByte ();_gga .WriteByte (_bbc );};return _gf .MakeString (_gga .String ()),nil ;};var _fca =_f .MustCompile ("\u0028\u005c\u0064\u002b)\\\u0073\u002b\u0028\u005c\u0064\u002b\u0029\u005c\u0073\u002b\u006f\u0062\u006a");
func (_cee *fdfParser )parseNull ()(_gf .PdfObjectNull ,error ){_ ,_efe :=_cee ._gde .Discard (4);return _gf .PdfObjectNull {},_efe ;};func (_fad *fdfParser )readComment ()(string ,error ){var _dbba _gb .Buffer ;_ ,_fce :=_fad .skipSpaces ();if _fce !=nil {return _dbba .String (),_fce ;
};_bddg :=true ;for {_adgf ,_fbe :=_fad ._gde .Peek (1);if _fbe !=nil {_dg .Log .Debug ("\u0045\u0072\u0072\u006f\u0072\u0020\u0025\u0073",_fbe .Error ());return _dbba .String (),_fbe ;};if _bddg &&_adgf [0]!='%'{return _dbba .String (),_c .New ("c\u006f\u006d\u006d\u0065\u006e\u0074 \u0073\u0068\u006f\u0075\u006c\u0064\u0020\u0073\u0074a\u0072\u0074\u0020w\u0069t\u0068\u0020\u0025");
};_bddg =false ;if (_adgf [0]!='\r')&&(_adgf [0]!='\n'){_beg ,_ :=_fad ._gde .ReadByte ();_dbba .WriteByte (_beg );}else {break ;};};return _dbba .String (),nil ;};func (_ebe *fdfParser )skipSpaces ()(int ,error ){_bfa :=0;for {_dgb ,_beb :=_ebe ._gde .ReadByte ();
if _beb !=nil {return 0,_beb ;};if _gf .IsWhiteSpace (_dgb ){_bfa ++;}else {_ebe ._gde .UnreadByte ();break ;};};return _bfa ,nil ;};func (_dcc *fdfParser )parseIndirectObject ()(_gf .PdfObject ,error ){_agbb :=_gf .PdfIndirectObject {};_dg .Log .Trace ("\u002dR\u0065a\u0064\u0020\u0069\u006e\u0064i\u0072\u0065c\u0074\u0020\u006f\u0062\u006a");
_fedc ,_gcd :=_dcc ._gde .Peek (20);if _gcd !=nil {_dg .Log .Debug ("\u0045\u0052\u0052\u004f\u0052\u003a\u0020\u0046\u0061\u0069\u006c\u0020\u0074\u006f\u0020r\u0065a\u0064\u0020\u0069\u006e\u0064\u0069\u0072\u0065\u0063\u0074\u0020\u006f\u0062\u006a");
return &_agbb ,_gcd ;};_dg .Log .Trace ("\u0028\u0069\u006edi\u0072\u0065\u0063\u0074\u0020\u006f\u0062\u006a\u0020\u0070\u0065\u0065\u006b\u0020\u0022\u0025\u0073\u0022",string (_fedc ));_ace :=_fca .FindStringSubmatchIndex (string (_fedc ));if len (_ace )< 6{_dg .Log .Debug ("\u0045\u0052\u0052\u004f\u0052\u003a\u0020U\u006e\u0061\u0062l\u0065\u0020\u0074\u006f \u0066\u0069\u006e\u0064\u0020\u006f\u0062\u006a\u0065\u0063\u0074\u0020\u0073\u0069\u0067\u006e\u0061\u0074\u0075\u0072\u0065\u0020\u0028\u0025\u0073\u0029",string (_fedc ));
return &_agbb ,_c .New ("\u0075\u006e\u0061b\u006c\u0065\u0020\u0074\u006f\u0020\u0064\u0065\u0074\u0065\u0063\u0074\u0020\u0069\u006e\u0064\u0069\u0072\u0065\u0063\u0074\u0020\u006f\u0062\u006a\u0065\u0063\u0074\u0020s\u0069\u0067\u006e\u0061\u0074\u0075\u0072\u0065");
};_dcc ._gde .Discard (_ace [0]);_dg .Log .Trace ("O\u0066\u0066\u0073\u0065\u0074\u0073\u0020\u0025\u0020\u0064",_ace );_gad :=_ace [1]-_ace [0];_aae :=make ([]byte ,_gad );_ ,_gcd =_dcc .readAtLeast (_aae ,_gad );if _gcd !=nil {_dg .Log .Debug ("\u0045\u0052\u0052\u004f\u0052\u003a\u0020\u0075\u006e\u0061\u0062l\u0065\u0020\u0074\u006f\u0020\u0072\u0065\u0061\u0064\u0020-\u0020\u0025\u0073",_gcd );
return nil ,_gcd ;};_dg .Log .Trace ("\u0074\u0065\u0078t\u006c\u0069\u006e\u0065\u003a\u0020\u0025\u0073",_aae );_cbde :=_fca .FindStringSubmatch (string (_aae ));if len (_cbde )< 3{_dg .Log .Debug ("\u0045\u0052\u0052\u004f\u0052\u003a\u0020U\u006e\u0061\u0062l\u0065\u0020\u0074\u006f \u0066\u0069\u006e\u0064\u0020\u006f\u0062\u006a\u0065\u0063\u0074\u0020\u0073\u0069\u0067\u006e\u0061\u0074\u0075\u0072\u0065\u0020\u0028\u0025\u0073\u0029",string (_aae ));
return &_agbb ,_c .New ("\u0075\u006e\u0061b\u006c\u0065\u0020\u0074\u006f\u0020\u0064\u0065\u0074\u0065\u0063\u0074\u0020\u0069\u006e\u0064\u0069\u0072\u0065\u0063\u0074\u0020\u006f\u0062\u006a\u0065\u0063\u0074\u0020s\u0069\u0067\u006e\u0061\u0074\u0075\u0072\u0065");
};_bba ,_ :=_a .Atoi (_cbde [1]);_bfee ,_ :=_a .Atoi (_cbde [2]);_agbb .ObjectNumber =int64 (_bba );_agbb .GenerationNumber =int64 (_bfee );for {_ffg ,_dbc :=_dcc ._gde .Peek (2);if _dbc !=nil {return &_agbb ,_dbc ;};_dg .Log .Trace ("I\u006ed\u002e\u0020\u0070\u0065\u0065\u006b\u003a\u0020%\u0073\u0020\u0028\u0025 x\u0029\u0021",string (_ffg ),string (_ffg ));
if _gf .IsWhiteSpace (_ffg [0]){_dcc .skipSpaces ();}else if _ffg [0]=='%'{_dcc .skipComments ();}else if (_ffg [0]=='<')&&(_ffg [1]=='<'){_dg .Log .Trace ("\u0043\u0061\u006c\u006c\u0020\u0050\u0061\u0072\u0073e\u0044\u0069\u0063\u0074");_agbb .PdfObject ,_dbc =_dcc .parseDict ();
_dg .Log .Trace ("\u0045\u004f\u0046\u0020Ca\u006c\u006c\u0020\u0050\u0061\u0072\u0073\u0065\u0044\u0069\u0063\u0074\u003a\u0020%\u0076",_dbc );if _dbc !=nil {return &_agbb ,_dbc ;};_dg .Log .Trace ("\u0050\u0061\u0072\u0073\u0065\u0064\u0020\u0064\u0069\u0063t\u0069\u006f\u006e\u0061\u0072\u0079\u002e.\u002e\u0020\u0066\u0069\u006e\u0069\u0073\u0068\u0065\u0064\u002e");
}else if (_ffg [0]=='/')||(_ffg [0]=='(')||(_ffg [0]=='[')||(_ffg [0]=='<'){_agbb .PdfObject ,_dbc =_dcc .parseObject ();if _dbc !=nil {return &_agbb ,_dbc ;};_dg .Log .Trace ("P\u0061\u0072\u0073\u0065\u0064\u0020o\u0062\u006a\u0065\u0063\u0074\u0020\u002e\u002e\u002e \u0066\u0069\u006ei\u0073h\u0065\u0064\u002e");
}else {if _ffg [0]=='e'{_fedd ,_fceb :=_dcc .readTextLine ();if _fceb !=nil {return nil ,_fceb ;};if len (_fedd )>=6&&_fedd [0:6]=="\u0065\u006e\u0064\u006f\u0062\u006a"{break ;};}else if _ffg [0]=='s'{_ffg ,_ =_dcc ._gde .Peek (10);if string (_ffg [:6])=="\u0073\u0074\u0072\u0065\u0061\u006d"{_ege :=6;
if len (_ffg )> 6{if _gf .IsWhiteSpace (_ffg [_ege ])&&_ffg [_ege ]!='\r'&&_ffg [_ege ]!='\n'{_dg .Log .Debug ("\u004e\u006fn\u002d\u0063\u006f\u006e\u0066\u006f\u0072\u006d\u0061\u006e\u0074\u0020\u0046\u0044\u0046\u0020\u006e\u006f\u0074 \u0065\u006e\u0064\u0069\u006e\u0067 \u0073\u0074\u0072\u0065\u0061\u006d\u0020\u006c\u0069\u006e\u0065\u0020\u0070\u0072o\u0070\u0065r\u006c\u0079\u0020\u0077i\u0074\u0068\u0020\u0045\u004fL\u0020\u006d\u0061\u0072\u006b\u0065\u0072");
_ege ++;};if _ffg [_ege ]=='\r'{_ege ++;if _ffg [_ege ]=='\n'{_ege ++;};}else if _ffg [_ege ]=='\n'{_ege ++;};};_dcc ._gde .Discard (_ege );_gba ,_bfae :=_agbb .PdfObject .(*_gf .PdfObjectDictionary );if !_bfae {return nil ,_c .New ("\u0073\u0074\u0072\u0065\u0061\u006d\u0020\u006f\u0062\u006a\u0065\u0063\u0074\u0020\u006di\u0073s\u0069\u006e\u0067\u0020\u0064\u0069\u0063\u0074\u0069\u006f\u006e\u0061\u0072\u0079");
};_dg .Log .Trace ("\u0053\u0074\u0072\u0065\u0061\u006d\u0020\u0064\u0069c\u0074\u0020\u0025\u0073",_gba );_eag ,_addd :=_gba .Get ("\u004c\u0065\u006e\u0067\u0074\u0068").(*_gf .PdfObjectInteger );if !_addd {return nil ,_c .New ("\u0073\u0074re\u0061\u006d\u0020l\u0065\u006e\u0067\u0074h n\u0065ed\u0073\u0020\u0074\u006f\u0020\u0062\u0065 a\u006e\u0020\u0069\u006e\u0074\u0065\u0067e\u0072");
};_ggb :=*_eag ;if _ggb < 0{return nil ,_c .New ("\u0073\u0074\u0072\u0065\u0061\u006d\u0020\u006e\u0065\u0065\u0064\u0073\u0020\u0074\u006f \u0062e\u0020\u006c\u006f\u006e\u0067\u0065\u0072\u0020\u0074\u0068\u0061\u006e\u0020\u0030");};if int64 (_ggb )> _dcc ._gaf {_dg .Log .Debug ("\u0045\u0052R\u004f\u0052\u003a\u0020\u0053t\u0072\u0065\u0061\u006d\u0020l\u0065\u006e\u0067\u0074\u0068\u0020\u0063\u0061\u006e\u006e\u006f\u0074\u0020\u0062\u0065\u0020\u006c\u0061\u0072\u0067\u0065\u0072\u0020\u0074\u0068\u0061\u006e\u0020\u0066\u0069\u006c\u0065\u0020\u0073\u0069\u007a\u0065");
return nil ,_c .New ("\u0069n\u0076\u0061l\u0069\u0064\u0020\u0073t\u0072\u0065\u0061m\u0020\u006c\u0065\u006e\u0067\u0074\u0068\u002c\u0020la\u0072\u0067\u0065r\u0020\u0074h\u0061\u006e\u0020\u0066\u0069\u006ce\u0020\u0073i\u007a\u0065");};_geea :=make ([]byte ,_ggb );
_ ,_dbc =_dcc .readAtLeast (_geea ,int (_ggb ));if _dbc !=nil {_dg .Log .Debug ("E\u0052\u0052\u004f\u0052 s\u0074r\u0065\u0061\u006d\u0020\u0028%\u0064\u0029\u003a\u0020\u0025\u0058",len (_geea ),_geea );_dg .Log .Debug ("\u0045R\u0052\u004f\u0052\u003a\u0020\u0025v",_dbc );
return nil ,_dbc ;};_fceg :=_gf .PdfObjectStream {};_fceg .Stream =_geea ;_fceg .PdfObjectDictionary =_agbb .PdfObject .(*_gf .PdfObjectDictionary );_fceg .ObjectNumber =_agbb .ObjectNumber ;_fceg .GenerationNumber =_agbb .GenerationNumber ;_dcc .skipSpaces ();
_dcc ._gde .Discard (9);_dcc .skipSpaces ();return &_fceg ,nil ;};};_agbb .PdfObject ,_dbc =_dcc .parseObject ();return &_agbb ,_dbc ;};};_dg .Log .Trace ("\u0052\u0065\u0074\u0075rn\u0069\u006e\u0067\u0020\u0069\u006e\u0064\u0069\u0072\u0065\u0063\u0074\u0021");
return &_agbb ,nil ;};

// FieldDictionaries returns a map of field names to field dictionaries.
func (fdf *Data )FieldDictionaries ()(map[string ]*_gf .PdfObjectDictionary ,error ){_fe :=map[string ]*_gf .PdfObjectDictionary {};for _bg :=0;_bg < fdf ._bd .Len ();_bg ++{_ad ,_dfb :=_gf .GetDict (fdf ._bd .Get (_bg ));if _dfb {_bb ,_ :=_gf .GetString (_ad .Get ("\u0054"));
if _bb !=nil {_fe [_bb .Str ()]=_ad ;};};};return _fe ,nil ;};func (_eed *fdfParser )parseFdfVersion ()(int ,int ,error ){_eed ._ga .Seek (0,_ac .SeekStart );_cad :=20;_bfe :=make ([]byte ,_cad );_eed ._ga .Read (_bfe );_gca :=_gee .FindStringSubmatch (string (_bfe ));
if len (_gca )< 3{_gbf ,_deaa ,_bdc :=_eed .seekFdfVersionTopDown ();if _bdc !=nil {_dg .Log .Debug ("F\u0061\u0069\u006c\u0065\u0064\u0020\u0072\u0065\u0063\u006f\u0076\u0065\u0072\u0079\u0020\u002d\u0020\u0075n\u0061\u0062\u006c\u0065\u0020\u0074\u006f\u0020\u0066\u0069nd\u0020\u0076\u0065r\u0073i\u006f\u006e");
return 0,0,_bdc ;};return _gbf ,_deaa ,nil ;};_aef ,_fgd :=_a .Atoi (_gca [1]);if _fgd !=nil {return 0,0,_fgd ;};_afd ,_fgd :=_a .Atoi (_gca [2]);if _fgd !=nil {return 0,0,_fgd ;};_dg .Log .Debug ("\u0046\u0064\u0066\u0020\u0076\u0065\u0072\u0073\u0069\u006f\u006e\u0020%\u0064\u002e\u0025\u0064",_aef ,_afd );
return _aef ,_afd ,nil ;};func _eba (_bga string )(_gf .PdfObjectReference ,error ){_ffec :=_gf .PdfObjectReference {};_dda :=_dd .FindStringSubmatch (_bga );if len (_dda )< 3{_dg .Log .Debug ("\u0045\u0072\u0072or\u0020\u0070\u0061\u0072\u0073\u0069\u006e\u0067\u0020\u0072\u0065\u0066\u0065\u0072\u0065\u006e\u0063\u0065");
return _ffec ,_c .New ("\u0075n\u0061\u0062\u006c\u0065 \u0074\u006f\u0020\u0070\u0061r\u0073e\u0020r\u0065\u0066\u0065\u0072\u0065\u006e\u0063e");};_ef ,_eea :=_a .Atoi (_dda [1]);if _eea !=nil {_dg .Log .Debug ("\u0045\u0072\u0072\u006f\u0072\u0020\u0070a\u0072\u0073\u0069n\u0067\u0020\u006fb\u006a\u0065c\u0074\u0020\u006e\u0075\u006d\u0062e\u0072 '\u0025\u0073\u0027\u0020\u002d\u0020\u0055\u0073\u0069\u006e\u0067\u0020\u006f\u0062\u006a\u0065\u0063\u0074\u0020\u006e\u0075\u006d\u0020\u003d\u0020\u0030",_dda [1]);
return _ffec ,nil ;};_ffec .ObjectNumber =int64 (_ef );_fgb ,_eea :=_a .Atoi (_dda [2]);if _eea !=nil {_dg .Log .Debug ("\u0045\u0072r\u006f\u0072\u0020\u0070\u0061r\u0073\u0069\u006e\u0067\u0020g\u0065\u006e\u0065\u0072\u0061\u0074\u0069\u006f\u006e\u0020\u006e\u0075\u006d\u0062\u0065\u0072\u0020\u0027\u0025\u0073\u0027\u0020\u002d\u0020\u0055\u0073\u0069\u006e\u0067\u0020\u0067\u0065\u006e\u0020\u003d\u0020\u0030",_dda [2]);
return _ffec ,nil ;};_ffec .GenerationNumber =int64 (_fgb );return _ffec ,nil ;};func (_cabc *fdfParser )trace (_cba _gf .PdfObject )_gf .PdfObject {switch _befd :=_cba .(type ){case *_gf .PdfObjectReference :_bce ,_bbd :=_cabc ._ca [_befd .ObjectNumber ].(*_gf .PdfIndirectObject );
if _bbd {return _bce .PdfObject ;};_dg .Log .Debug ("\u0054\u0079\u0070\u0065\u0020\u0065\u0072\u0072\u006f\u0072");return nil ;case *_gf .PdfIndirectObject :return _befd .PdfObject ;};return _cba ;};var _bad =_f .MustCompile ("\u005e\u005b\u005c\u002b\u002d\u002e\u005d\u002a\u0028\u005b\u0030\u002d9\u002e\u005d\u002b\u0029");
type fdfParser struct{_gbd int ;_dbb int ;_ca map[int64 ]_gf .PdfObject ;_ga _ac .ReadSeeker ;_gde *_b .Reader ;_gaf int64 ;_eab *_gf .PdfObjectDictionary ;};func (_bdd *fdfParser )readAtLeast (_aa []byte ,_ed int )(int ,error ){_adg :=_ed ;_cdf :=0;_ba :=0;
for _adg > 0{_ab ,_gddg :=_bdd ._gde .Read (_aa [_cdf :]);if _gddg !=nil {_dg .Log .Debug ("\u0045\u0052\u0052O\u0052\u0020\u0046\u0061i\u006c\u0065\u0064\u0020\u0072\u0065\u0061d\u0069\u006e\u0067\u0020\u0028\u0025\u0064\u003b\u0025\u0064\u0029\u0020\u0025\u0073",_ab ,_ba ,_gddg .Error ());
return _cdf ,_c .New ("\u0066\u0061\u0069\u006c\u0065\u0064\u0020\u0072\u0065a\u0064\u0069\u006e\u0067");};_ba ++;_cdf +=_ab ;_adg -=_ab ;};return _cdf ,nil ;};func (_dag *fdfParser )parseBool ()(_gf .PdfObjectBool ,error ){_aaa ,_fed :=_dag ._gde .Peek (4);
if _fed !=nil {return _gf .PdfObjectBool (false ),_fed ;};if (len (_aaa )>=4)&&(string (_aaa [:4])=="\u0074\u0072\u0075\u0065"){_dag ._gde .Discard (4);return _gf .PdfObjectBool (true ),nil ;};_aaa ,_fed =_dag ._gde .Peek (5);if _fed !=nil {return _gf .PdfObjectBool (false ),_fed ;
};if (len (_aaa )>=5)&&(string (_aaa [:5])=="\u0066\u0061\u006cs\u0065"){_dag ._gde .Discard (5);return _gf .PdfObjectBool (false ),nil ;};return _gf .PdfObjectBool (false ),_c .New ("\u0075n\u0065\u0078\u0070\u0065c\u0074\u0065\u0064\u0020\u0062o\u006fl\u0065a\u006e\u0020\u0073\u0074\u0072\u0069\u006eg");
};var _be =_f .MustCompile ("\u0025\u0025\u0045O\u0046");func (_cg *fdfParser )parseArray ()(*_gf .PdfObjectArray ,error ){_bfgc :=_gf .MakeArray ();_cg ._gde .ReadByte ();for {_cg .skipSpaces ();_ebg ,_geeg :=_cg ._gde .Peek (1);if _geeg !=nil {return _bfgc ,_geeg ;
};if _ebg [0]==']'{_cg ._gde .ReadByte ();break ;};_cgd ,_geeg :=_cg .parseObject ();if _geeg !=nil {return _bfgc ,_geeg ;};_bfgc .Append (_cgd );};return _bfgc ,nil ;};var _dd =_f .MustCompile ("^\u005c\u0073\u002a\u0028\\d\u002b)\u005c\u0073\u002b\u0028\u005cd\u002b\u0029\u005c\u0073\u002b\u0052");
func (_cef *fdfParser )parseHexString ()(*_gf .PdfObjectString ,error ){_cef ._gde .ReadByte ();var _cec _gb .Buffer ;for {_deb ,_ddg :=_cef ._gde .Peek (1);if _ddg !=nil {return _gf .MakeHexString (""),_ddg ;};if _deb [0]=='>'{_cef ._gde .ReadByte ();
break ;};_daa ,_ :=_cef ._gde .ReadByte ();if !_gf .IsWhiteSpace (_daa ){_cec .WriteByte (_daa );};};if _cec .Len ()%2==1{_cec .WriteRune ('0');};_dde ,_gfa :=_af .DecodeString (_cec .String ());if _gfa !=nil {_dg .Log .Debug ("\u0045\u0052\u0052\u004f\u0052\u0020\u0050\u0061\u0072\u0073\u0069\u006e\u0067\u0020\u0068\u0065\u0078\u0020\u0073\u0074r\u0069\u006e\u0067\u003a\u0020\u0027\u0025\u0073\u0027 \u002d\u0020\u0072\u0065\u0074\u0075\u0072\u006e\u0069\u006e\u0067\u0020\u0061n\u0020\u0065\u006d\u0070\u0074\u0079 \u0073\u0074\u0072i\u006e\u0067",_cec .String ());
return _gf .MakeHexString (""),nil ;};return _gf .MakeHexString (string (_dde )),nil ;};

// FieldValues implements interface model.FieldValueProvider.
// Returns a map of field names to values (PdfObjects).
func (fdf *Data )FieldValues ()(map[string ]_gf .PdfObject ,error ){_db ,_cb :=fdf .FieldDictionaries ();if _cb !=nil {return nil ,_cb ;};var _ce []string ;for _gc :=range _db {_ce =append (_ce ,_gc );};_ff .Strings (_ce );_fb :=map[string ]_gf .PdfObject {};
for _ ,_ea :=range _ce {_cbc :=_db [_ea ];_gg :=_gf .TraceToDirectObject (_cbc .Get ("\u0056"));_fb [_ea ]=_gg ;};return _fb ,nil ;};func _bfea (_eee string )(*fdfParser ,error ){_cdec :=fdfParser {};_afed :=[]byte (_eee );_abe :=_gb .NewReader (_afed );
_cdec ._ga =_abe ;_cdec ._ca =map[int64 ]_gf .PdfObject {};_dgce :=_b .NewReader (_abe );_cdec ._gde =_dgce ;_cdec ._gaf =int64 (len (_eee ));return &_cdec ,_cdec .parse ();};func (_ega *fdfParser )skipComments ()error {if _ ,_fd :=_ega .skipSpaces ();
_fd !=nil {return _fd ;};_dca :=true ;for {_ee ,_bcf :=_ega ._gde .Peek (1);if _bcf !=nil {_dg .Log .Debug ("\u0045\u0072\u0072\u006f\u0072\u0020\u0025\u0073",_bcf .Error ());return _bcf ;};if _dca &&_ee [0]!='%'{return nil ;};_dca =false ;if (_ee [0]!='\r')&&(_ee [0]!='\n'){_ega ._gde .ReadByte ();
}else {break ;};};return _ega .skipComments ();};func (_def *fdfParser )seekFdfVersionTopDown ()(int ,int ,error ){_def ._ga .Seek (0,_ac .SeekStart );_def ._gde =_b .NewReader (_def ._ga );_dcb :=20;_cbdca :=make ([]byte ,_dcb );for {_eged ,_cdba :=_def ._gde .ReadByte ();
if _cdba !=nil {if _cdba ==_ac .EOF {break ;}else {return 0,0,_cdba ;};};if _gf .IsDecimalDigit (_eged )&&_cbdca [_dcb -1]=='.'&&_gf .IsDecimalDigit (_cbdca [_dcb -2])&&_cbdca [_dcb -3]=='-'&&_cbdca [_dcb -4]=='F'&&_cbdca [_dcb -5]=='D'&&_cbdca [_dcb -6]=='P'{_fedf :=int (_cbdca [_dcb -2]-'0');
_bbcg :=int (_eged -'0');return _fedf ,_bbcg ,nil ;};_cbdca =append (_cbdca [1:_dcb ],_eged );};return 0,0,_c .New ("\u0076\u0065\u0072\u0073\u0069\u006f\u006e\u0020\u006e\u006f\u0074\u0020f\u006f\u0075\u006e\u0064");};func (_fc *fdfParser )getFileOffset ()int64 {_ec ,_ :=_fc ._ga .Seek (0,_ac .SeekCurrent );
_ec -=int64 (_fc ._gde .Buffered ());return _ec ;};func (_ae *fdfParser )setFileOffset (_eg int64 ){_ae ._ga .Seek (_eg ,_ac .SeekStart );_ae ._gde =_b .NewReader (_ae ._ga );};func (_ada *fdfParser )parseNumber ()(_gf .PdfObject ,error ){return _gf .ParseNumber (_ada ._gde )};


// Data represents forms data format (FDF) file data.
type Data struct{_df *_gf .PdfObjectDictionary ;_bd *_gf .PdfObjectArray ;};func (_bcg *fdfParser )parseDict ()(*_gf .PdfObjectDictionary ,error ){_dg .Log .Trace ("\u0052\u0065\u0061\u0064\u0069\u006e\u0067\u0020\u0046\u0044\u0046\u0020D\u0069\u0063\u0074\u0021");
_ebd :=_gf .MakeDict ();_ffd ,_ :=_bcg ._gde .ReadByte ();if _ffd !='<'{return nil ,_c .New ("\u0069\u006e\u0076a\u006c\u0069\u0064\u0020\u0064\u0069\u0063\u0074");};_ffd ,_ =_bcg ._gde .ReadByte ();if _ffd !='<'{return nil ,_c .New ("\u0069\u006e\u0076a\u006c\u0069\u0064\u0020\u0064\u0069\u0063\u0074");
};for {_bcg .skipSpaces ();_bcg .skipComments ();_bbca ,_bgab :=_bcg ._gde .Peek (2);if _bgab !=nil {return nil ,_bgab ;};_dg .Log .Trace ("D\u0069c\u0074\u0020\u0070\u0065\u0065\u006b\u003a\u0020%\u0073\u0020\u0028\u0025 x\u0029\u0021",string (_bbca ),string (_bbca ));
if (_bbca [0]=='>')&&(_bbca [1]=='>'){_dg .Log .Trace ("\u0045\u004f\u0046\u0020\u0064\u0069\u0063\u0074\u0069o\u006e\u0061\u0072\u0079");_bcg ._gde .ReadByte ();_bcg ._gde .ReadByte ();break ;};_dg .Log .Trace ("\u0050a\u0072s\u0065\u0020\u0074\u0068\u0065\u0020\u006e\u0061\u006d\u0065\u0021");
_dfe ,_bgab :=_bcg .parseName ();_dg .Log .Trace ("\u004be\u0079\u003a\u0020\u0025\u0073",_dfe );if _bgab !=nil {_dg .Log .Debug ("E\u0052\u0052\u004f\u0052\u0020\u0052e\u0074\u0075\u0072\u006e\u0069\u006e\u0067\u0020\u006ea\u006d\u0065\u0020e\u0072r\u0020\u0025\u0073",_bgab );
return nil ,_bgab ;};if len (_dfe )> 4&&_dfe [len (_dfe )-4:]=="\u006e\u0075\u006c\u006c"{_bgc :=_dfe [0:len (_dfe )-4];_dg .Log .Debug ("\u0054\u0061\u006b\u0069n\u0067\u0020\u0063\u0061\u0072\u0065\u0020\u006f\u0066\u0020n\u0075l\u006c\u0020\u0062\u0075\u0067\u0020\u0028%\u0073\u0029",_dfe );
_dg .Log .Debug ("\u004e\u0065\u0077\u0020ke\u0079\u0020\u0022\u0025\u0073\u0022\u0020\u003d\u0020\u006e\u0075\u006c\u006c",_bgc );_bcg .skipSpaces ();_bade ,_ :=_bcg ._gde .Peek (1);if _bade [0]=='/'{_ebd .Set (_bgc ,_gf .MakeNull ());continue ;};};_bcg .skipSpaces ();
_dea ,_bgab :=_bcg .parseObject ();if _bgab !=nil {return nil ,_bgab ;};_ebd .Set (_dfe ,_dea );_dg .Log .Trace ("\u0064\u0069\u0063\u0074\u005b\u0025\u0073\u005d\u0020\u003d\u0020\u0025\u0073",_dfe ,_dea .String ());};_dg .Log .Trace ("\u0072\u0065\u0074\u0075rn\u0069\u006e\u0067\u0020\u0046\u0044\u0046\u0020\u0044\u0069\u0063\u0074\u0021");
return _ebd ,nil ;};var _bf =_f .MustCompile ("\u005e\u005b\u005c+-\u002e\u005d\u002a\u0028\u005b\u0030\u002d\u0039\u002e]\u002b)\u0065[\u005c+\u002d\u002e\u005d\u002a\u0028\u005b\u0030\u002d\u0039\u002e\u005d\u002b\u0029");func (_gbe *fdfParser )parseObject ()(_gf .PdfObject ,error ){_dg .Log .Trace ("\u0052e\u0061d\u0020\u0064\u0069\u0072\u0065c\u0074\u0020o\u0062\u006a\u0065\u0063\u0074");
_gbe .skipSpaces ();for {_dgc ,_fcf :=_gbe ._gde .Peek (2);if _fcf !=nil {return nil ,_fcf ;};_dg .Log .Trace ("\u0050e\u0065k\u0020\u0073\u0074\u0072\u0069\u006e\u0067\u003a\u0020\u0025\u0073",string (_dgc ));if _dgc [0]=='/'{_fcc ,_cde :=_gbe .parseName ();
_dg .Log .Trace ("\u002d\u003e\u004ea\u006d\u0065\u003a\u0020\u0027\u0025\u0073\u0027",_fcc );return &_fcc ,_cde ;}else if _dgc [0]=='('{_dg .Log .Trace ("\u002d>\u0053\u0074\u0072\u0069\u006e\u0067!");return _gbe .parseString ();}else if _dgc [0]=='['{_dg .Log .Trace ("\u002d\u003e\u0041\u0072\u0072\u0061\u0079\u0021");
return _gbe .parseArray ();}else if (_dgc [0]=='<')&&(_dgc [1]=='<'){_dg .Log .Trace ("\u002d>\u0044\u0069\u0063\u0074\u0021");return _gbe .parseDict ();}else if _dgc [0]=='<'{_dg .Log .Trace ("\u002d\u003e\u0048\u0065\u0078\u0020\u0073\u0074\u0072\u0069\u006e\u0067\u0021");
return _gbe .parseHexString ();}else if _dgc [0]=='%'{_gbe .readComment ();_gbe .skipSpaces ();}else {_dg .Log .Trace ("\u002d\u003eN\u0075\u006d\u0062e\u0072\u0020\u006f\u0072\u0020\u0072\u0065\u0066\u003f");_dgc ,_ =_gbe ._gde .Peek (15);_fba :=string (_dgc );
_dg .Log .Trace ("\u0050\u0065\u0065k\u0020\u0073\u0074\u0072\u003a\u0020\u0025\u0073",_fba );if (len (_fba )> 3)&&(_fba [:4]=="\u006e\u0075\u006c\u006c"){_dgf ,_bgdf :=_gbe .parseNull ();return &_dgf ,_bgdf ;}else if (len (_fba )> 4)&&(_fba [:5]=="\u0066\u0061\u006cs\u0065"){_fdb ,_ggaa :=_gbe .parseBool ();
return &_fdb ,_ggaa ;}else if (len (_fba )> 3)&&(_fba [:4]=="\u0074\u0072\u0075\u0065"){_acc ,_bgb :=_gbe .parseBool ();return &_acc ,_bgb ;};_aec :=_dd .FindStringSubmatch (_fba );if len (_aec )> 1{_dgc ,_ =_gbe ._gde .ReadBytes ('R');_dg .Log .Trace ("\u002d\u003e\u0020\u0021\u0052\u0065\u0066\u003a\u0020\u0027\u0025\u0073\u0027",string (_dgc [:]));
_bda ,_fcd :=_eba (string (_dgc ));return &_bda ,_fcd ;};_afec :=_bad .FindStringSubmatch (_fba );if len (_afec )> 1{_dg .Log .Trace ("\u002d\u003e\u0020\u004e\u0075\u006d\u0062\u0065\u0072\u0021");return _gbe .parseNumber ();};_afec =_bf .FindStringSubmatch (_fba );
if len (_afec )> 1{_dg .Log .Trace ("\u002d\u003e\u0020\u0045xp\u006f\u006e\u0065\u006e\u0074\u0069\u0061\u006c\u0020\u004e\u0075\u006d\u0062\u0065r\u0021");_dg .Log .Trace ("\u0025\u0020\u0073",_afec );return _gbe .parseNumber ();};_dg .Log .Debug ("\u0045R\u0052\u004f\u0052\u0020U\u006e\u006b\u006e\u006f\u0077n\u0020(\u0070e\u0065\u006b\u0020\u0022\u0025\u0073\u0022)",_fba );
return nil ,_c .New ("\u006f\u0062\u006a\u0065\u0063t\u0020\u0070\u0061\u0072\u0073\u0069\u006e\u0067\u0020\u0065\u0072\u0072\u006fr\u0020\u002d\u0020\u0075\u006e\u0065\u0078\u0070\u0065\u0063\u0074\u0065\u0064\u0020\u0070\u0061\u0074\u0074\u0065\u0072\u006e");
};};};

// Load loads FDF form data from `r`.
func Load (r _ac .ReadSeeker )(*Data ,error ){_dc ,_e :=_gfac (r );if _e !=nil {return nil ,_e ;};_cd ,_e :=_dc .Root ();if _e !=nil {return nil ,_e ;};_fa ,_eb :=_gf .GetArray (_cd .Get ("\u0046\u0069\u0065\u006c\u0064\u0073"));if !_eb {return nil ,_c .New ("\u0066\u0069\u0065\u006c\u0064\u0073\u0020\u006d\u0069s\u0073\u0069\u006e\u0067");
};return &Data {_bd :_fa ,_df :_cd },nil ;};func _gfac (_efc _ac .ReadSeeker )(*fdfParser ,error ){_bbab :=&fdfParser {};_bbab ._ga =_efc ;_bbab ._ca =map[int64 ]_gf .PdfObject {};_bbcc ,_dcd ,_ffge :=_bbab .parseFdfVersion ();if _ffge !=nil {_dg .Log .Error ("U\u006e\u0061\u0062\u006c\u0065\u0020t\u006f\u0020\u0070\u0061\u0072\u0073\u0065\u0020\u0076e\u0072\u0073\u0069o\u006e:\u0020\u0025\u0076",_ffge );
return nil ,_ffge ;};_bbab ._gbd =_bbcc ;_bbab ._dbb =_dcd ;_ffge =_bbab .parse ();return _bbab ,_ffge ;};